SystemOrganization addCategory: #'SDL-Specs-FFI'!

SDLCodeGenerator subclass: #SDLFFICodeGenerator
	instanceVariableNames: 'unknownTypes typeAliases'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SDL-Specs-FFI'!

!SDLFFICodeGenerator methodsFor: 'FFI code generation' stamp: 'NickAlexander 1/8/2012 18:43'!
functionsInto: aStream forClass: aClassName 
	aStream nextPutAll: 'ExternalLibrary subclass: #' , aClassName , '
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''' , self category , '''. !!';
		 cr;
		 cr.

	aStream nextPut: $!!;
		nextPutAll: aClassName, ' class';
		nextPutAll: ' methodsFor: ''';
		nextPutAll: 'accessing';
		nextPutAll: ''' stamp: ''';
		nextPutAll: Author changeStamp;
		nextPutAll: '''!!';
		cr;
		nextPutAll: 'moduleName';
		crtab;
		nextPutAll: '^ ''SDL13''';
		cr;
		nextPutAll: '!! !!';
		cr.
	
	api functions
		do: [:fn | 
			aStream nextPut: $!!;
				 nextPutAll: aClassName;
				 nextPutAll: ' methodsFor: ''';
				 nextPutAll: fn headerFileName;
				 nextPutAll: ''' stamp: ''';
				 nextPutAll: Author changeStamp;
				 nextPutAll: '''!!';
				 cr.
			aStream
				nextPutAll: (self sourceForFunction: fn).
			aStream nextPutAll: '!! !!';
				 cr]! !

!SDLFFICodeGenerator methodsFor: 'FFI code generation' stamp: 'NickAlexander 1/3/2012 08:29'!
handlesInto: aStream forClass: aClassName 
	aStream cr; nextPutAll: 'ExternalData subclass: #' , aClassName , 'ExternalHandle' , '
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''' , self category , '''. !!'; cr; cr.
	self handles do: [ :e | aStream
		cr;
		nextPutAll: aClassName , 'ExternalHandle subclass: #' , e, '
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''' , self category , '''. !!'; cr; cr]! !

!SDLFFICodeGenerator methodsFor: 'FFI code generation' stamp: 'NickAlexander 1/2/2012 22:40'!
initialize
	unknownTypes := Set new.! !

!SDLFFICodeGenerator methodsFor: 'accessing' stamp: 'NickAlexander 1/1/2012 19:10'!
prefixString
	^ 'FFI'! !

!SDLFFICodeGenerator methodsFor: 'FFI code generation' stamp: 'NickAlexander 1/8/2012 18:43'!
sourceForFunction: fn
	^ String
		streamContents: [:str |
			str
				nextPutAll: fn name.
			fn params keys notEmpty
				ifTrue: [ str
					nextPutAll: ': ';
					nextPutAll: fn params keys first ].
			fn params keys
				allButFirstDo: [:param | str
					nextPutAll: ' ';
					nextPutAll: param;
					nextPutAll: ': ';
					nextPutAll: param ].

			str
				crtab;
				nextPutAll: '"This method was automatically generated from SDL 1.3 headers"';
				crtab;
				nextPutAll: '"See http://squeaksource.com/SDLSpecs for details"';
				crtab;
				"<cdecl: FFITestPoint2 'ffiTestStruct64' (FFITestPoint2 FFITestPoint2) module:'SqueakFFIPrims'>"
				nextPutAll: '<cdecl: ';
				nextPutAll: (self typeNameFor: fn returnType);
				nextPutAll: ' ';
				nextPutAll: fn name surroundedBySingleQuotes;
				nextPutAll: ' ('.
			fn params keys
				do: [:param | str
						crtab;
						nextPutAll: (self typeNameFor: (fn params at: param));
						nextPutAll: ' "', param, '"'.
				].
			str crtab;
			nextPutAll: ')>';
			crtab;
			nextPutAll: '^self externalCallFailed'.	
	]! !

!SDLFFICodeGenerator methodsFor: 'FFI code generation' stamp: 'NickAlexander 1/3/2012 08:45'!
sourceForStruct: struct
	^ String
		streamContents: [:str | 
			str nextPutAll: 'fields';
				 crtab;
				 nextPutAll: '"This method was automatically generated from SDL 1.3 headers"';
				 crtab;
				 nextPutAll: '"See http://squeaksource.com/SDLSpecs for details"';
				 crtab;
				 nextPutAll: '^ #('.
			struct valueNames
				keysAndValuesDo: [:k :v | str crtab; tab;
					nextPut: $(;
					nextPutAll: k; 
					nextPutAll: ' ';
					nextPut: $';
					nextPutAll: (self typeNameFor: v);
					nextPut: $';
					nextPut: $).
			].
			str crtab nextPutAll: ')';
				 crtab;
				 crtab]! !

!SDLFFICodeGenerator methodsFor: 'FFI code generation' stamp: 'NickAlexander 1/2/2012 22:48'!
structsInto: aStream forClass: aClassName 

	aStream nextPutAll: 'ExternalStructure subclass: #' , aClassName , 'ExternalStructure
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''' , self category , '''. !!';
		 cr;
		 cr.
	aStream nextPutAll: aClassName , 'ExternalStructure subclass: #' , aClassName , 'AbstractEvent
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''' , self category , '''. !!';
		 cr;
		 cr.
	api structs
		do: [:e | 
			aStream nextPutAll: ((e name endsWith: 'Event')
					ifTrue: [aClassName , 'AbstractEvent']
					ifFalse: [aClassName , 'ExternalStructure'])
					, ' subclass: #' , e name , '
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''' , self category , '''. !!';
				 cr.
			aStream nextPut: $!!;
				 nextPutAll: e name , ' class';
				 nextPutAll: ' methodsFor: ''';
				 nextPutAll: e headerFileName;
				 nextPutAll: ''' stamp: ''';
				 nextPutAll: Author changeStamp;
				 nextPutAll: '''!!';
				 cr.
			aStream
				nextPutAll: (self sourceForStruct: e).
			aStream nextPutAll: '!! !!';
				 cr].
	api structs
		keysDo: [:k | aStream cr; nextPutAll: k , ' defineFields. !!'].
	aStream cr; cr; nextPutAll: 'SDL_MouseMotionEvent subclass: #SDL_Event
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''' , self category , '''. !!'; cr; cr! !

!SDLFFICodeGenerator methodsFor: 'FFI code generation' stamp: 'NickAlexander 1/2/2012 23:09'!
typeAliases
	^ typeAliases
		ifNil: [typeAliases := Dictionary new.
			self typeAliasesAssocs
				do: [:each | typeAliases add: each].
			typeAliases]! !

!SDLFFICodeGenerator methodsFor: 'FFI code generation' stamp: 'NickAlexander 1/2/2012 23:08'!
typeAliasesAssocs
	^ {#Uint8 -> #byte. #Uint16 -> #ushort. #Uint32 -> #ulong. #Uint64 -> #ulonglong. #int -> #long. #SDL_bool -> #char. #SDL_errorcode -> #long. #SDL_GLattr -> #long. #SDL_Scancode -> #long. #SDL_Keycode -> #long. #Sint8 -> #char. #Sint16 -> #short. #Sint32 -> #long. #Sint64 -> #longlong. #SDL_TimerID -> #long. #SDL_TouchID -> #longlong. #SDL_FingerID -> #longlong. #SDL_GestureID -> #longlong. #SDL_Keymod -> #long}! !

!SDLFFICodeGenerator methodsFor: 'FFI code generation' stamp: 'NickAlexander 1/3/2012 12:35'!
typeNameFor: aName 
	(self handles includes: aName)
		ifTrue: [ ^ aName ].
	(ExternalType atomicTypeNamed: aName)
		ifNotNil: [^ aName].
	self typeAliases
		at: aName
		ifPresent: [ :v | ^ v ].
	api enums
		at: aName
		ifPresent: [ :e | ^ #long ].
	api structs
		at: aName
		ifPresent: [:v | ^ aName].
	api unions
		at: aName
		ifPresent: [:v | ^ aName].
	aName last = $*
		ifTrue: [^ (self typeNameFor: aName allButLast), '*'].
	unknownTypes add: aName.
	^ aName! !

!SDLFFICodeGenerator methodsFor: 'as yet unclassified' stamp: 'NickAlexander 1/8/2012 18:54'!
writeFileInsToDirectory: aString
	super writeFileInsToDirectory: aString.
	unknownTypes notEmpty ifTrue: [ self error: 'unknown types found: ', unknownTypes asString ]! !
